import calendar
import json
from datetime import datetime, timedelta

from vender.quant_api_base import base_Quant_api


class Quant_api(base_Quant_api):

    def _rebalance(self, pt):

        """
        是否需要 rebalance
        :param pt:
        :return: 返回 model_portfolio 的 rp_id 表示需要 rebalance ，若是不需要 rebalance 返回 0
        """

        def last_busi_date(day_str: str):
            year = int(day_str[:4])
            month = int(day_str[4:6])
            _, last_day = calendar.monthrange(year, month)
            last_day_date = datetime(year, month, last_day)
            last_day_date = last_day_date.replace(hour=23, minute=59, second=59, microsecond=997000)
            while last_day_date.weekday() >= 5:  # weekday() 返回0-6，5是周六，6是周日
                last_day_date -= timedelta(days=1)
            return last_day_date.strftime('%Y-%m-%d %H:%M:%S.%f')[:-3]

        model_portfolio = self.get_latest_portfolio(pt['recomm_id'])
        if not pt.get('rp_id') or pt.get('rp_id') != model_portfolio['rp_id']:
            # 如果推薦生成日data_Date在最後一次觸發再平衡时间之后，视为需要再平衡
            if (not pt.get('last_recomm_date') or type(pt.get('last_recomm_date')) != str or
                    model_portfolio['data_Date'] > pt.get('last_recomm_date').replace('-', '')):
                note = json.loads(model_portfolio.get('note'))
                if not note.get('recomm_reason'):
                    raise RuntimeError('未輸入推薦理由')
                return model_portfolio.get('rp_id'), '月初調倉日', last_busi_date(
                    model_portfolio['data_Date']), note.get(
                    'recomm_reason')
        return 0

    def _dividend(self, pt):
        # 投組不涉及配息
        pass
